void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->ADD10_OUT,0,retain)
  __INIT_VAR(data__->EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SEL15_OUT,0,retain)
  __INIT_VAR(data__->AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->ADD10_OUT,)));
  __SET_VAR(data__->,SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (UINT)__GET_VAR(data__->ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->SEL15_OUT,));
  __SET_VAR(data__->,AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void IF_WORD_BOOL_init__(IF_WORD_BOOL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,0,retain)
  __INIT_VAR(data__->OUT0,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL_COMP,32768,retain)
  __INIT_VAR(data__->OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void IF_WORD_BOOL_body__(IF_WORD_BOOL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->IN0,) > __GET_VAR(data__->VAL_COMP,))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // IF_WORD_BOOL_body__() 





void IF_BOOL_WORD_init__(IF_BOOL_WORD *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,0,retain)
  __INIT_VAR(data__->OUT1,65535,retain)
  __INIT_VAR(data__->VAL0,0,retain)
  __INIT_VAR(data__->OUT,0,retain)
}

// Code part
void IF_BOOL_WORD_body__(IF_BOOL_WORD *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if (__GET_VAR(data__->IN0,)) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // IF_BOOL_WORD_body__() 





void IF_WORD_WORD_init__(IF_WORD_WORD *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,0,retain)
  __INIT_VAR(data__->OUT0,65535,retain)
  __INIT_VAR(data__->OUT1,0,retain)
  __INIT_VAR(data__->VAL0,0,retain)
  __INIT_VAR(data__->VAL_COMP,32767,retain)
  __INIT_VAR(data__->OUT,0,retain)
}

// Code part
void IF_WORD_WORD_body__(IF_WORD_WORD *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->IN0,) > __GET_VAR(data__->VAL_COMP,))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // IF_WORD_WORD_body__() 





void PI_LED_AN_NO_PULL_init__(PI_LED_AN_NO_PULL *data__, BOOL retain) {
  __INIT_VAR(data__->OUT_23,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_22,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_25,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_20,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->INP_AN0,0,retain)
  __INIT_VAR(data__->INP_AN1,0,retain)
  __INIT_VAR(data__->INP_AN2,0,retain)
  __INIT_VAR(data__->INP_AN3,0,retain)
  TOF_init__(&data__->TOF3,retain);
  TOF_init__(&data__->TOF4,retain);
  TOF_init__(&data__->TOF5,retain);
  __INIT_VAR(data__->LT32_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GE31_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->AND33_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->LT28_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GE27_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->AND29_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->LT44_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GE43_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->AND47_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PI_LED_AN_NO_PULL_body__(PI_LED_AN_NO_PULL *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->,LT32_OUT,,LT__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->INP_AN0,),
    (UINT)100));
  __SET_VAR(data__->,GE31_OUT,,GE__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->INP_AN0,),
    (UINT)90));
  __SET_VAR(data__->,AND33_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->LT32_OUT,),
    (BOOL)__GET_VAR(data__->GE31_OUT,)));
  __SET_VAR(data__->TOF5.,IN,,__GET_VAR(data__->AND33_OUT,));
  __SET_VAR(data__->TOF5.,PT,,__time_to_timespec(1, 50, 0, 0, 0, 0));
  TOF_body__(&data__->TOF5);
  __SET_VAR(data__->,OUT_23,,__GET_VAR(data__->TOF5.Q,));
  __SET_VAR(data__->,LT28_OUT,,LT__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->INP_AN0,),
    (UINT)130));
  __SET_VAR(data__->,GE27_OUT,,GE__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->INP_AN0,),
    (UINT)120));
  __SET_VAR(data__->,AND29_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->LT28_OUT,),
    (BOOL)__GET_VAR(data__->GE27_OUT,)));
  __SET_VAR(data__->TOF4.,IN,,__GET_VAR(data__->AND29_OUT,));
  __SET_VAR(data__->TOF4.,PT,,__time_to_timespec(1, 50, 0, 0, 0, 0));
  TOF_body__(&data__->TOF4);
  __SET_VAR(data__->,OUT_22,,__GET_VAR(data__->TOF4.Q,));
  __SET_VAR(data__->,LT44_OUT,,LT__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->INP_AN0,),
    (UINT)85));
  __SET_VAR(data__->,GE43_OUT,,GE__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->INP_AN0,),
    (UINT)75));
  __SET_VAR(data__->,AND47_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->LT44_OUT,),
    (BOOL)__GET_VAR(data__->GE43_OUT,)));
  __SET_VAR(data__->TOF3.,IN,,__GET_VAR(data__->AND47_OUT,));
  __SET_VAR(data__->TOF3.,PT,,__time_to_timespec(1, 50, 0, 0, 0, 0));
  TOF_body__(&data__->TOF3);
  __SET_VAR(data__->,OUT_25,,__GET_VAR(data__->TOF3.Q,));

  goto __end;

__end:
  return;
} // PI_LED_AN_NO_PULL_body__() 





